Option Explicit

#include local-parameters.inc
#include ..\lib\framework_domotics.vbs

Const SW_HIDE					= 0
Const SW_SHOWNORMAL				= 1 
Const LIB_NOBACKUP				= "No Backup"
Const LIB_BACKUPDONE			= "Backup Done (with ##MINUTES## min.)"

'--------------------------------------------------------------------
'-- OBJECTIVE   : PROCEDURE >> MAIN PROGRAM FOR BACKUP
'-- PREREQUISITE: N/A
'-- PARAMS IN   : N/A
'-- PARAMS OUT  : N/A
'-- CREATED BY DOMOTICS
'-- 27/01/2006
'--------------------------------------------------------------------
Sub main
Dim i
Dim astrDevices
Dim astrDevice
Dim astrConfig
Dim atabDv
Dim astrNbDv
Dim astrBACKUP_FOLDER
Dim atabBackups
Dim astrSubFolder
Dim astrPREPROCESSING
Dim astrROOT_FOLDER
Dim astrTMP_FOLDER

'-- Use The following instruction when your script is release
' on error resume next

WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Launching " & G_FOLDER_NAME & " script", G_LOG_FILE

If CheckDevices(G_FOLDER_NAME, G_FILE_INI, G_STATUS_EXIST) Then
		astrDevices 		= hs.GetINISetting("COMMON","DEVICES","", G_FILE_INI)
		astrConfig  		= hs.GetINISetting("COMMON","CONFIG","..\scripts\config\", G_FILE_INI)
		atabDv	 			= Split(astrDevices, G_SEP)
		astrNbDv 			= UBound(atabDv) 
		astrBACKUP_FOLDER	= hs.GetINISetting("COMMON","BACKUP_FOLDER","",G_FILE_INI)				
		astrROOT_FOLDER 	= hs.GetINISetting("COMMON","ROOT_FOLDER","",G_FILE_INI)
		astrTMP_FOLDER 		= hs.GetINISetting("COMMON","TMP_FOLDER","",G_FILE_INI)
		
		WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Preparing backup within " & astrBACKUP_FOLDER, G_LOG_FILE
		If isFolderExist(astrBACKUP_FOLDER) Then
			astrBACKUP_FOLDER = astrBACKUP_FOLDER & formatDate4FileSys(Now)
			createFolder(astrBACKUP_FOLDER)
			WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Lauching backup within " & astrBACKUP_FOLDER, G_LOG_FILE
			i=0
			While (i <= Cint(astrNbDv))	
				astrDevice 			= hs.GetINISetting("DEVICE", "HC", "", astrConfig & atabDv(i)) & _ 
			  					  	  hs.GetINISetting("DEVICE", "DC", "", astrConfig & atabDv(i))						
				atabBackups 		= Split(hs.GetINISetting("DEVICE", "PARAM1", "", astrConfig & atabDv(i)),G_SEP)
				astrSubFolder		= hs.GetINISetting("DEVICE", "PARAM2", "", astrConfig & atabDv(i))     
				astrPREPROCESSING  	= hs.GetINISetting("DEVICE", "PARAM3", "", astrConfig & atabDv(i))  
   				
				SetDevice astrDevice, LIB_NOBACKUP, "", ""
				
				If astrPREPROCESSING <> "" Then
					WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Lauching preprocessing function", G_LOG_FILE	
					runPreProcessing astrDevice, astrPREPROCESSING & " " & astrBACKUP_FOLDER
				End if
				
				WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Lauching back-up function", G_LOG_FILE
				runBackup astrDevice, atabBackups, astrBACKUP_FOLDER, astrSubFolder							
				i=i+1
			Wend
			
			WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Lauching compression function", G_LOG_FILE
			compressBackup astrDevice, astrBACKUP_FOLDER
			
			WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Lauching upload function", G_LOG_FILE
			uploadBackup astrDevice	
			
			WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Deleting temporary files and folders", G_LOG_FILE
			deleteFolder astrBACKUP_FOLDER
			deleteFile	astrROOT_FOLDER & astrTMP_FOLDER & "\" & formatDate4FileSys(Now) & ".tar.gz"
		Else
			WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_SEV, "Problem with backup folder ! (" & astrBACKUP_FOLDER & ")", G_LOG_FILE			
		End if		
Else
	WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_SEV, "Expected Device is unknown !", G_LOG_FILE
End if

WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "End of the script", G_LOG_FILE
End sub

'--------------------------------------------------------------------
'-- OBJECTIVE   : PROCEDURE >> RUN PREPROCESSING
'-- PREREQUISITE: N/A
'-- PARAMS IN   : N/A
'-- PARAMS OUT  : N/A
'-- CREATED BY DOMOTICS
'-- 27/01/2006
'--------------------------------------------------------------------
Sub runPreProcessing(astrDevice, astrPREPROCESSING)
If executeShell(astrPREPROCESSING) Then
	WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, astrDevice & " preprocessing has been executed with success", G_LOG_FILE
Else
	WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, astrDevice & " preprocessing has been executed with failure", G_LOG_FILE					
End If
End sub

'--------------------------------------------------------------------
'-- OBJECTIVE   : PROCEDURE >> COPY FILE FOR MAKING BACKUP
'-- PREREQUISITE: N/A
'-- PARAMS IN   : N/A
'-- PARAMS OUT  : N/A
'-- CREATED BY DOMOTICS
'-- 27/01/2006
'--------------------------------------------------------------------
Sub runBackup(astrDevice, atabBackups, astrBACKUP_FOLDER, astrSubFolder)
Dim aboolBackup
Dim adateBegin
Dim f
Dim atabTargetedSubFolder
Dim astrBuffer
Dim astrXCOPY_BIN
Dim astrCOPY_BIN
Dim astrCmdLine

astrXCOPY_BIN  		= hs.GetINISetting("COMMON","XCOPY_BIN","",G_FILE_INI)
astrCOPY_BIN 		= hs.GetINISetting("COMMON","COPY_BIN","",G_FILE_INI)

WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Detecting " & ubound(atabBackups)+1 & " folders for " & astrSubFolder, G_LOG_FILE
			
aboolBackup = False
createFolder(astrBACKUP_FOLDER & "\" & astrSubFolder)
adateBegin=Now()
f=0
While  (f <= Ubound(atabBackups))
	atabTargetedSubFolder = Split(atabBackups(f),",")
	If Ubound(atabTargetedSubFolder) = 1 Then
		WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, atabTargetedSubFolder(0) &"," & atabTargetedSubFolder(1), G_LOG_FILE
		If atabTargetedSubFolder(0) <> "" Then
			astrBuffer = astrBACKUP_FOLDER & "\" & astrSubFolder & "\" & atabTargetedSubFolder(0) & "\"
			createFolder(astrBuffer)
		Else 
			astrBuffer = astrBACKUP_FOLDER & "\" & astrSubFolder & "\" 
		End if
					
		astrCmdLine = ""
		
		If instr(atabTargetedSubFolder(1),"*") > 0 Then
			astrCmdLine = astrCmdLine & astrXCOPY_BIN
		Else
			astrCmdLine = astrCmdLine & astrCOPY_BIN
		End if
			
		astrCmdLine = astrCmdLine & " " & atabTargetedSubFolder(1)
		astrCmdLine = astrCmdLine & " " & astrBuffer 
		WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, replace(astrCmdLine,"\","-"), G_LOG_FILE							
		
		If executeShell(astrCmdLine) Then
			WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Launching copy to " & astrBuffer, G_LOG_FILE
			aboolBackup = True
		Else
			WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, astrBuffer & " not found. Copy is impossible !!!", G_LOG_FILE					
		End If 
	Else
		WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, atabBackups(f) & " has an invalid format, we expect - folder, source - like - html,c:\html\* - !!!", G_LOG_FILE
	End if
	f=f+1
Wend
				
If aboolBackup Then
	SetDevice astrDevice, replace(LIB_BACKUPDONE, "##MINUTES##",Cstr(DateDiff("N",adateBegin,Now()))), "", ""
'-- "Backup Done (with " & Cstr(DateDiff("N",adateBegin,Now())) &" min.)"
Else
	SetDevice astrDevice, LIB_NOBACKUP, "", ""
End If

End Sub

'--------------------------------------------------------------------
'-- OBJECTIVE   : PROCEDURE >> Control Media Periodically
'-- PREREQUISITE: N/A
'-- PARAMS IN   : N/A
'-- PARAMS OUT  : N/A
'-- CREATED BY DOMOTICS
'-- 27/01/2006
'--------------------------------------------------------------------
Sub compressBackup(astrDevice, astrBACKUP_FOLDER)
Dim astrDISK
Dim astrROOT_FOLDER
Dim astrTMP_FOLDER
Dim astrGZ_BIN
Dim astrTAR_BIN
Dim astrCmdLine

astrGZ_BIN  		= hs.GetINISetting("COMMON","GZ_BIN","",G_FILE_INI)
astrTAR_BIN 		= hs.GetINISetting("COMMON","TAR_BIN","",G_FILE_INI)
astrDISK 			= hs.GetINISetting("COMMON","DISK","",G_FILE_INI)
astrROOT_FOLDER 	= hs.GetINISetting("COMMON","ROOT_FOLDER","",G_FILE_INI)
astrTMP_FOLDER 		= hs.GetINISetting("COMMON","TMP_FOLDER","",G_FILE_INI)

deleteFile astrDISK & astrROOT_FOLDER & astrTMP_FOLDER & formatDate4FileSys(Now) & ".tar"
deleteFile astrDISK & astrROOT_FOLDER & astrTMP_FOLDER & formatDate4FileSys(Now) & ".tar.gz"

WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Using " & astrDISK & astrROOT_FOLDER & astrTAR_BIN, G_LOG_FILE
WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Using " & astrDISK & astrROOT_FOLDER & astrGZ_BIN, G_LOG_FILE

If (astrTAR_BIN <> "") and (astrGZ_BIN <> "") Then  
	astrCmdLine    = astrDISK & astrROOT_FOLDER & astrTAR_BIN & " cvf " & astrROOT_FOLDER & astrTMP_FOLDER & _
					 formatDate4FileSys(Now) & ".tar " & replace(astrBACKUP_FOLDER,"\","/") & "\/*" 
	
	WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Launching .tar generation", G_LOG_FILE
	If executeShell(astrCmdLine) Then
		astrCmdLine = astrDISK & astrROOT_FOLDER & astrGZ_BIN & " " & astrDISK & astrROOT_FOLDER & astrTMP_FOLDER & _
					  formatDate4FileSys(Now) & ".tar"
		WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "TAR generated with success", G_LOG_FILE
		WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Launching .gz generation", G_LOG_FILE
		If executeShell(astrCmdLine) Then
			WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "GZ generated with success", G_LOG_FILE
		Else
			WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, "GZ generated with failure", G_LOG_FILE
		End if
	Else
		WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, "TAR generated with failure", G_LOG_FILE
	End if
Else
	WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, " TAR and GZ variables are empty !!!", G_LOG_FILE
End If
End Sub

'--------------------------------------------------------------------
'-- OBJECTIVE   : PROCEDURE >> Control Media Periodically
'-- PREREQUISITE: N/A
'-- PARAMS IN   : N/A
'-- PARAMS OUT  : N/A
'-- CREATED BY DOMOTICS
'-- 27/01/2006
'--------------------------------------------------------------------
Sub uploadBackup(astrDevice)
Dim astrWAKEUP
Dim astrHOST_TO
Dim astrUSERNAME
Dim astrPASSWORD
Dim astrDISK
Dim astrROOT_FOLDER
Dim astrTMP_FOLDER
Dim astrREMOTE_FOLDER
Dim astrError
Dim astrLocalFileName
Dim astrRemoteFileName

astrDISK 			= hs.GetINISetting("COMMON","DISK","",G_FILE_INI)
astrROOT_FOLDER 	= hs.GetINISetting("COMMON","ROOT_FOLDER","",G_FILE_INI)
astrTMP_FOLDER 		= hs.GetINISetting("COMMON","TMP_FOLDER","",G_FILE_INI)					  
astrWAKEUP  		= hs.GetINISetting("COMMON","WAKEUP","FALSE",G_FILE_INI)
astrHOST_TO  		= hs.GetINISetting("COMMON","HOST_TO","192.168.1.103",G_FILE_INI)
astrUSERNAME  		= hs.GetINISetting("COMMON","USERNAME","",G_FILE_INI)
astrPASSWORD  		= hs.GetINISetting("COMMON","PASSWORD","",G_FILE_INI)
astrREMOTE_FOLDER	= hs.GetINISetting("COMMON","REMOTE_FOLDER","",G_FILE_INI)

If (astrHOST_TO <> "") and (astrUSERNAME <> "") and (astrPASSWORD <> "") Then
	If UCASE(astrWAKEUP) = "TRUE" Then
		WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Trying to wakeup the FTP server", G_LOG_FILE
	Else
		WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Wakeup is not required", G_LOG_FILE
	End if
	
	astrRemoteFileName	= formatDate4FileSys(Now) & ".tar.gz"
	astrLocalFileName	= astrDISK & astrROOT_FOLDER & astrTMP_FOLDER & astrRemoteFileName	
	WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Params : " & replace(astrHOST_TO & "," & astrUSERNAME & "," & astrPASSWORD & ",put," & astrREMOTE_FOLDER & "," & astrLocalFileName & "," & astrRemoteFileName,"\","-"), G_LOG_FILE
	hs.ftp astrHOST_TO, astrUSERNAME, astrPASSWORD, "put", astrREMOTE_FOLDER, astrLocalFileName, astrRemoteFileName
	astrError = hs.ftplasterror
	
	
	If astrError = "" Then
		WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Upload has been successfull", G_LOG_FILE
	Else
		WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, "FTP upload has failed : " & astrError & " !!!", G_LOG_FILE
	End if
End if
End sub

'--------------------------------------------------------------------
'-- OBJECTIVE   : PROCEDURE >> Delete a file
'-- PREREQUISITE: N/A
'-- PARAMS IN   : N/A
'-- PARAMS OUT  : N/A
'-- CREATED BY DOMOTICS
'-- 27/01/2006
'--------------------------------------------------------------------
Sub deleteFile(astrFile)
Dim filesys

Set filesys = CreateObject("Scripting.FileSystemObject")
If filesys.FileExists(astrFile) Then
	filesys.DeleteFile astrFile
End if
Set filesys = Nothing
End Sub